// ActionScript file
//Annotation Editor functions

import flash.display.Shape;
import flash.display.Sprite;
import flash.events.MouseEvent;
import mx.collections.ArrayCollection;
import mx.controls.Alert;
import mx.controls.Label;
import mx.core.UIComponent;

     
  
private var item:Sprite;
[Bindable] private var drawing:Boolean = false;
[Bindable] private var mode:uint = 0;
private var beginX:Number = 0;
private var beginY:Number = 0;
private var hold:UIComponent = null;

[Bindable]
public var fontlist:ArrayCollection = new ArrayCollection(
  [ {label:"Arial"}, 
  {label:"Times New Roman"}, 
  {label:"Courier New"},
  {label:"Georgia"},
  {label:"Verdana"} ]);

private function loadAnnotation():void
{
 videoCanvas.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
 videoCanvas.addEventListener(MouseEvent.MOUSE_UP, onMouseUp)  
 videoCanvas.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove); 
}

private function hideAnnotation():void
{
 videoCanvas.removeEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
 videoCanvas.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp)  
 videoCanvas.removeEventListener(MouseEvent.MOUSE_MOVE, onMouseMove); 
}


private function onMouseDown(event:MouseEvent):void
 {
 	if(mode==4) //Text
 	 {
 	   if(!this.EdtText.text)
 	    	Alert.show("Text field empty!","Error");
 	   else
 	    {
 	      drawAText(event.localX,event.localY);	
 	    }	
 	 }
 	else
 	 { 
 	  drawing=true;
 	  hold=null;
 	  beginX=event.localX;
 	  beginY=event.localY;
 	  if(mode==0 || mode==1)
    	{
   	     item= new Sprite();
         var c:UIComponent=new UIComponent();
 	     c.addChild(item);
 	     item.graphics.lineStyle(this.hslider1.value, this.lineColor.selectedColor);
 	     item.graphics.moveTo(event.localX,event.localY);
 	     videoCanvas.addChild(c);
  	   }
  	 }  
 }

 private function onMouseUp(event:MouseEvent):void
  {
  	if(mode==1)
  	 item.graphics.lineTo(event.localX,event.localY);


  	drawing=false;
  	//trace("stop:" + event.localX + "/" + event.localY);
  }
  
 private function onMouseMove(event:MouseEvent):void
  {
  	if(drawing)
      {
  	 	if(mode==0) //Freehand
  	 	 item.graphics.lineTo(event.localX,event.localY);
  	 	else if(mode==2) //Rectangle
  	      {
  	  	    if (hold) 
  	  	     videoCanvas.removeChild(hold);
  	  	    drawARect(beginX,beginY,event.localX-beginX,event.localY-beginY);
  	      }  
  	    else if(mode==3) //Circle
  	     {
  	    	if(hold)
  	  	      videoCanvas.removeChild(hold);
  	 	    var radius:Number= ((event.localX-beginX)^2 + (event.localY-beginY)^2); 
  	  	    drawACircle(beginX, beginY,radius); 
  	     }   

      }
  	//trace("move:" + event.localX + "/" + event.localY ); 
  } 
  
 private function drawARect(x:Number,y:Number,w:Number,h:Number):UIComponent
 {
 	var aBox:Shape= new Shape();
 	var c:UIComponent= new UIComponent();
 	aBox.graphics.lineStyle(this.hslider1.value,this.lineColor.selectedColor);
 	aBox.graphics.beginFill(this.fillColor.selectedColor,1);
 	aBox.graphics.drawRect(x, y, w, h);
 	aBox.graphics.endFill();
 	c.addChild(aBox);
 	videoCanvas.addChild(c);
 	return c;
 } 
 
 
 private function drawACircle(x:Number, y:Number, r:Number):UIComponent 
 {
 	var aCircle:Shape= new Shape();
    var c:UIComponent= new UIComponent();
    aCircle.graphics.lineStyle(this.hslider1.value,this.lineColor.selectedColor);
    aCircle.graphics.beginFill(this.fillColor.selectedColor,1);    
    aCircle.graphics.drawCircle(x, y, r);
    aCircle.graphics.endFill();
    c.addChild(aCircle);
    videoCanvas.addChild(c);
    return c;
  }
  
 private function drawAText(x:Number,y:Number):Label
 {
 	var aLabel:Label= new Label();
    aLabel.text=EdtText.text;
    aLabel.setStyle("fontSize",this.hslider1.value);
    aLabel.setStyle("color",lineColor.selectedColor);
    aLabel.setStyle("fontFamily",FontSelBox.selectedLabel);
    if(BoldCB.selected)
     aLabel.setStyle("fontWeight","bold");
    if(ItalicCB.selected)
     aLabel.setStyle("fontStyle","italic"); 
    if(UnderlineCB.selected)
     aLabel.setStyle("textDecoration","underline");  
 	aLabel.move(x,y);
    videoCanvas.addChild(aLabel);
    return aLabel;
 }

  
 private function ClearCanvas():void
  {
   if(this.videoCanvas.numChildren>1)	
    while(this.videoCanvas.numChildren>1)	
     this.videoCanvas.removeChildAt(this.videoCanvas.numChildren-1);
  }
  
  