// ActionScript file
//Video mixer functions
  
  import mx.controls.Alert;
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.display.StageDisplayState;
  import flash.events.Event;
  import flash.events.ProgressEvent;
  import flash.events.TimerEvent;
  import flash.media.Camera;
  import flash.media.Sound;
  import flash.media.SoundChannel;
  import flash.media.SoundTransform;
  import flash.net.URLRequest;
  import flash.utils.Timer;
  
  import mx.controls.ComboBox;
  import mx.controls.HSlider;
  import mx.controls.Label;
  import mx.controls.VideoDisplay;
  import mx.events.SliderEvent;
  import mx.rpc.events.FaultEvent;
  import mx.rpc.events.ResultEvent;
  import mx.rpc.http.mxml.HTTPService;
  
  private var seekTo:Number;
  
  //Playlist XML file
  public var playlisturl:String="assets/playList.xml";
  
  [Bindable]
  private var playlist:XMLList;
  [Bindable]
  private var playlist1:XMLList;
  [Bindable]
  private var playlist2:XMLList;
  private var playlistCursor:uint;
  
  [Bindable]
  private var fileTotalBytes1:Number;
  [Bindable]
  private var fileTotalBytes2:Number;
  [Bindable]
  private var startLoop1:Number;
  [Bindable]
  private var endLoop1:Number;
  [Bindable]
  private var startLoop2:Number;
  [Bindable]
  private var endLoop2:Number;
  
  private var cam:Camera;
  
  private var sound1:Sound;
  private var sound2:Sound;
  public var SoundChannel1:SoundChannel = new SoundChannel();
  public var SoundChannel2:SoundChannel = new SoundChannel();
  [Bindable]
  private var SoundTransform1:SoundTransform = new SoundTransform();
  [Bindable]
  private var SoundTransform2:SoundTransform = new SoundTransform();
  

  private var volume1:Number;
  private var volume2:Number;
  private var pausePos1:Number=0;
  private var pausePos2:Number=0;
  
  private var AudioTimer1:Timer = new Timer(500);
  private var AudioTimer2:Timer = new Timer(500);
  [Bindable]
  private var fileLength1:Number=0;
  [Bindable]
  private var fileLength2:Number=0;
 

  private var vid1Bmp:Bitmap;	
  private var vid1Data:BitmapData;
  private var vid1DataFull:BitmapData;
  private var vid2Bmp:Bitmap;	
  private var vid2Data:BitmapData;
  private var vid2DataFull:BitmapData;
 
  
  private function init():void
  {
    loadPlaylist();
    init_filters();
    initBmp();
    initYouTube();
    AudioTimer1.addEventListener(TimerEvent.TIMER, updateAudio1);
    AudioTimer2.addEventListener(TimerEvent.TIMER, updateAudio2);
    systemManager.stage.addEventListener(FullScreenEvent.FULL_SCREEN, fullScreenHandler);
    this.vid1.addEventListener(ProgressEvent.PROGRESS, video1Progress);
    this.vid2.addEventListener(ProgressEvent.PROGRESS, video2Progress);
  }
  
  
  //Create Bitmap and BitmapData for both decks 	
  private function initBmp():void
  {
  	var width:int = this.videoCanvas.width;
  	var height:int = this.videoCanvas.height;
  	vid1.visible = false;
  	vid2.visible = false;
  	
  	vid1Data = new BitmapData(width,height,false,0x000000);
  	vid1DataFull = new BitmapData(this.stage.stageWidth,this.stage.stageHeight,false,0x000000);
  	vid1Bmp = new Bitmap(vid1Data,"auto",true);
  	videoUIComp.addChild(vid1Bmp);
  	  	
  	vid2Data = new BitmapData(width,height,false,0x000000);
  	vid2DataFull = new BitmapData(this.stage.stageWidth,this.stage.stageHeight,false,0x000000);
  	vid2Bmp = new Bitmap(vid2Data,"auto",true);
 	videoUIComp.addChild(vid2Bmp);

  	this.addEventListener(Event.ENTER_FRAME,onFrame);
  }
  
  //drawing frame loop setting the correct bitmap data sources to the two video monitors (bitnaps)
  private function onFrame(event:Event):void
  {
  	vid1Bmp.alpha = vid1.alpha;
  	vid2Bmp.alpha = vid2.alpha;
  	try
  	{
  		switch (systemManager.stage.displayState)
  		{
  			case StageDisplayState.FULL_SCREEN:
  			  	vid1Bmp.bitmapData = vid1DataFull; //bitmap data for full screen mode
  			  	if(this.youTubePlaying1)
  					vid1DataFull.draw(this.swfLoader1,null,null,null,null,true);
  				else
  					vid1DataFull.draw(vid1,null,null,null,null,true);
  				//Check if a blend mode filter is enabled (see lib.BlendFilterListener and modules.BlendFilterInterdace)
  				if(this._blend1Enabled) //blend filter enabled
  				{
  					vid1DataFull.draw(vid2DataFull,null,null, this._blendMode1);
  				}	
  				//same for deck 2	
  				vid2Bmp.bitmapData = vid2DataFull;
  				 if(this.youTubePlaying2)
  					vid2DataFull.draw(this.swfLoader2,null,null,null,null,true);
  				else
  					vid2DataFull.draw(vid2,null,null,null,null,true);
  				if(this._blend2Enabled)
  					{		
  							vid2DataFull.draw(vid1DataFull,null,null, this._blendMode2);
			   		}	
  				break;
  				
  				
  				
  			default :
  				vid1Bmp.bitmapData = vid1Data;
  				if(this.youTubePlaying1)
  					vid1Data.draw(this.swfLoader1,null,null,null,null,true);
  				else
  					vid1Data.draw(vid1,null,null,null,null,true);	
  		 		//Check if a blend mode filter is enabled (see lib.BlendFilterListener and modules.BlendFilterInterdace)
  				if(this._blend1Enabled) //blend filter enabled
  				{
  						vid1Data.draw(vid2Data,null,null, this._blendMode1);
  				}
  				vid2Bmp.bitmapData = vid2Data;
  				if(this.youTubePlaying2)
  					vid2Data.draw(this.swfLoader2,null,null,null,null,true);
  				else
  					vid2Data.draw(vid2,null,null,null,null,true);
  				//Check if a blend mode filter is enabled (see lib.BlendFilterListener and modules.BlendFilterInterdace)
  					if(this._blend2Enabled) //blend filter enabled
  					{
  							vid2Data.draw(vid1Data,null,null, this._blendMode2);
  					}
  			 	break;	
  		}
  	} 
  	catch (err:SecurityError)
    {
        trace(err);
     }
     
  	  		
  	//ASCII EFFECT
  	if(this._ascii1Enabled)
  	{
  		this._asciiEffect1.alpha = vid1.alpha;
  		this._asciiEffect1.width = videoUIComp.width;
  		this._asciiEffect1.height = videoUIComp.height;
  	}
  	
  	if(this._ascii2Enabled)
  	{
  		this._asciiEffect2.alpha = vid2.alpha;
  		this._asciiEffect2.width = videoUIComp.width;
  		this._asciiEffect2.height = videoUIComp.height;
  	}		
  }


//Full Screen 
private function toggleFullScreen():void 
{
   try
    {
         switch (systemManager.stage.displayState) 
         {
          case StageDisplayState.FULL_SCREEN:
               /* If already in full screen mode, switch to normal mode. */
               this.vid1.maintainAspectRatio = true;
 	           this.vid2.maintainAspectRatio = true;    
 	           this.vidPlaying1.selectedIndex = this.vidPlayingF1.selectedIndex;
 	           this.vidPlaying2.selectedIndex = this.vidPlayingF2.selectedIndex;  
 	           if(_ascii1Enabled)
  	 				_asciiEffect1._pixelSize = 6;
 	           if(_ascii2Enabled)
 	           		_asciiEffect2._pixelSize = 6;    
 	           systemManager.stage.displayState = StageDisplayState.NORMAL;
 	           
 	           if(this.youTubePlaying1)
 	           		this.callLater(this.resetPlayerSize,[this.youTubePlayer1]);
 	           if(this.youTubePlaying2)
 	           		this.callLater(this.resetPlayerSize,[this.youTubePlayer2]);		
               break;
           default:
               /* If not in full screen mode, switch to full screen mode. */
               currentState='fullScreen'; 
               filtersPanel.visible=false;
                 this.vid1.maintainAspectRatio = true;
               this.vid2.maintainAspectRatio = true;
               alphaSliderF.value = this.alphaSlider.value;
	           this.vidPlayingF1.selectedIndex = this.vidPlaying1.selectedIndex;
	           this.vidPlayingF2.selectedIndex = this.vidPlaying2.selectedIndex;

			   if(this._ascii1Enabled)
  	 				this._asciiEffect1._pixelSize = 12;
  	 		   if(this._ascii2Enabled)
  	 				this._asciiEffect2._pixelSize = 12;		
  	 				
               //var screenRectangle:Rectangle = new Rectangle(0, 0, videoPanel.width, videoPanel.height);
               //stage.fullScreenSourceRect = screenRectangle;
         
               systemManager.stage.displayState = StageDisplayState.FULL_SCREEN; 
               if(this.youTubePlaying1)
 	           		this.callLater(this.resetPlayerSize,[this.youTubePlayer1]);
 	           if(this.youTubePlaying2)
 	           		this.callLater(this.resetPlayerSize,[this.youTubePlayer2]);
               break;
          }
     } 
    catch (err:SecurityError)
     {
        trace(err);
     }
}


private function onFullMouseOver():void
{
	this.fullscreenVBox.alpha = 0.6;
	this.vidPlayingF1.visible = true;
	this.vidPlayingF2.visible = true;
	this.timeFullLabel1.visible = true;
	this.timeFullLabel2.visible = true;
}

private function onFullMouseOut():void
{
	this.fullscreenVBox.alpha = 0;
	this.vidPlayingF1.visible = false;
	this.vidPlayingF2.visible = false;
	this.timeFullLabel1.visible = false;
	this.timeFullLabel2.visible = false;
}

private function fullScreenHandler(evt:FullScreenEvent):void 
{
    if (evt.fullScreen) 
      {

		  
      }
     else 
      {
        currentState='';
 	    if(tabnavigator1.selectedIndex==1)
 	    	 filtersPanel.visible=true;
 	    if(this._ascii1Enabled)
  	 		this._asciiEffect1._pixelSize = 6;
  	 	if(this._ascii2Enabled)
  	 		this._asciiEffect2._pixelSize = 6;	
  	 	if(this.youTubePlaying1)
 	    	this.callLater(this.resetPlayerSize,[this.youTubePlayer1]);
 	    if(this.youTubePlaying2)
 	    	this.callLater(this.resetPlayerSize,[this.youTubePlayer2]);	
  	 		
      }  	
}

////////////////////////////////////////////////////////////////////////////////////  
  //Loads the XML playlist using HTTP
  private function loadPlaylist():void
  {	
  	playlistCursor=0;
  	var playlistService:HTTPService = new HTTPService();
  	playlistService.url=playlisturl;
  	playlistService.resultFormat="xml";
  	playlistService.showBusyCursor=true;
  	playlistService.addEventListener(ResultEvent.RESULT, onPlayListResult);
    playlistService.addEventListener(FaultEvent.FAULT, onFault);
    playlistService.send();
   }
   
   
   
  //Creates a XML node for the camera options and adds the xml results from HTTP request 
  private function onPlayListResult(event:ResultEvent):void
  {
  	trace(event.result);
    var resultXML:XML= new XML(event.result);
  	playlist = new XMLList();
  	var newNode:XML = <title>Camera</title>;
	playlist += newNode;
	playlist+=resultXML.clip;
	
	//init playlists
	playlist1 = playlist;
	playlist2 = playlist;
  }
  
  //HTTP request fault
  private function onFault(event:FaultEvent):void
  {
    trace(event.fault);
  }
  
  //Label Function for playlist combobox
  private function setLabel(item:Object):String
  {
   var label:String;	
   if(item.type=="audio")
    label = "A:" + item.title;
   else if(item.type=="video")
    label = "V:" + item.title; 
   else if(item.type=="youtube")
   	label = "Y:" + item.title; 
   else
    label = "Camera" 
   return label;
  }

  
  //Play video/camera/audio function
  private function playVideo(vid:VideoDisplay,combo:ComboBox):void
  {
  	
  	if(vid.id=="vid1")	//////DECK 1///////
  	{
  		//Check input source type
  		if(combo.selectedLabel=="Camera")  							//Camera
    	{
     		StartCamera(vid);
     		  //Disable loop controls
	    	  this.startSlider1.enabled=false;
	    	  this.startSlider1.value =0;
	 	  	  this.endSlider1.enabled=false;
	 	  	  this.endSlider1.value = 0;
	 	  	  this.timeLoopBgn1.text="";
	 	  	  this.timeLoopEnd1.text=""
	 	  	  this.loopBtn1.enabled=false;
	 	  	  this.thumbVid1.visible = false;
     		if(this.youTubePlaying1)	//stop youtube if playing
     		{
     			this.youTubePlayer1.stopVideo();
     			this.youTubeStopUpdate1();
     			this.youTubePlaying1 = false;
     		}     			
     		else //if(SoundChannel1.position!=0) //Stop audio if playing
     		{
     			SoundChannel1.stop();
    		 	AudioTimer1.stop();	
     		}
    	}
    	else if(this.playlist1[combo.selectedIndex].type=="audio")   //Audio
    	{
	    	  if(this.youTubePlaying1)
	 	  	  {
	 	  	  	this.youTubePlayer1.stopVideo();
	 	  	  	this.youTubeStopUpdate1();
	 	  	  	this.youTubePlaying1 = false;	
	 	  	  }
	 	  	  else if(this.vid1.playing)
	 	  	  {
	 	  	  	this.vid1.stop();
	 	  	  }	
	    	  sound1 = new Sound();	
	    	  sound1.load(new URLRequest(this.playlist1[combo.selectedIndex].file));
	    	  sound1.addEventListener(ProgressEvent.PROGRESS, progressHandler1);
	    	  sound1.addEventListener(Event.COMPLETE, sound1Loaded);
	    	  SoundTransform1.volume=this.volSlider1.value;
	    	  SoundChannel1 = sound1.play(pausePos1, 1, SoundTransform1);
	    	  AudioTimer1.start(); 
	    	  //Enable loop controls
	    	  this.startSlider1.enabled=true;
	 	  	  this.endSlider1.enabled=true;
	 	  	  this.timeLoopBgn1.text="0:00";
	 	  	  this.loopBtn1.enabled=true;
	 	  	  this.thumbVid1.visible = false;
    	} 
    	else if(this.playlist1[combo.selectedIndex].type=="video")		//Video
    	{
    		this.vid1.source = this.playlist1[combo.selectedIndex].file;
    		this.vid1.load();
    		this.vid1.play();
    		if(this.youTubePlaying1)	//stop youtube if playing
     		{
     			this.youTubePlayer1.stopVideo();
     			this.youTubeStopUpdate1();
     			this.youTubePlaying1 = false;
     		}
    		else //if(SoundChannel1.position!=0) //Stop audio if playing
    		{
    			SoundChannel1.stop();
    			AudioTimer1.stop();
    		}		
    		 
 	  		fileLength1 = this.vid1.totalTime;
 	  		this.startSlider1.enabled=true;
 	  		this.endSlider1.enabled=true;
 	  		this.timeLoopBgn1.text="0:00";
 	  		this.loopBtn1.enabled=true;
 	  		this.thumbVid1.visible = true;
    	}
    	else															//YouTube
    	{
    			if(this.vid1.playing) //stop video if playing
    			{
    				this.vid1.stop();
    			}
    			else //if(SoundChannel1.position!=0) //Stop audio if playing
    			{
    				SoundChannel1.stop();
    				AudioTimer1.stop();
    			}  
    			var w:Number = this.videoUIComp.width;
    			var h:Number = this.videoUIComp.height;
    			this.youTubePlayer1.setSize(w,h);
    			this.youTubePlayer1.playVideo();
    			this.youTubeStartUpdate1();
    			this.youTubePlaying1 = true;
    			
    			this.startSlider1.enabled=true;
 	  			this.endSlider1.enabled=true;
 	  			this.timeLoopBgn1.text="0:00";
 	  			this.loopBtn1.enabled=true;
    	}
    	pausePos1=0;
  	}
  	else 				//////DECK 2/////// 
  	{
 		//Check input source type
  		if(combo.selectedLabel=="Camera")  							//Camera
    	{
     		StartCamera(vid);
     		//Disable loop controls
	    	this.startSlider2.enabled=false;
	    	this.startSlider2.value = 0;
	 	  	this.endSlider2.enabled=false;
	 	  	this.endSlider2.value = 0;
	 	  	this.timeLoopBgn2.text="";
	 	  	this.timeLoopEnd2.text=""
	 	  	this.loopBtn2.enabled=false;
	 	  	this.thumbVid2.visible = false;
     		if(this.youTubePlaying2)	//stop youtube if playing
     		{
     			this.youTubePlayer2.stopVideo();
     			this.youTubeStopUpdate2();
     			this.youTubePlaying2 = false;
     		}     			
     		else //if(SoundChannel2.position!=0) //Stop audio if playing
     		{
     			SoundChannel2.stop();
    		 	AudioTimer2.stop();	
     		}
    	}
    	else if(this.playlist2[combo.selectedIndex].type=="audio")   //Audio
    	{
	    	  
	    	  if(this.youTubePlaying2)	//stop youtube if playing
     		  {
     				this.youTubePlayer2.stopVideo();
     				this.youTubeStopUpdate2();
     				this.youTubePlaying2 = false;
     		  }  
     		  else if(this.vid2.playing) //stop video if playing
     		  {
     		  		this.vid2.stop();
     		  }
	    	  sound2 = new Sound();	
	    	  sound2.load(new URLRequest(this.playlist2[combo.selectedIndex].file));
	    	  sound2.addEventListener(ProgressEvent.PROGRESS, progressHandler2);
	    	  sound2.addEventListener(Event.COMPLETE, sound2Loaded);
	    	  SoundTransform2.volume=this.volSlider2.value;
	    	  SoundChannel2 = sound2.play(pausePos2, 1, SoundTransform2);
	    	  AudioTimer2.start(); 
	    	  //Enable loop controls
	    	  this.startSlider2.enabled=true;
	 	  	  this.endSlider2.enabled=true;
	 	  	  this.timeLoopBgn2.text="0:00";
	 	  	  this.loopBtn2.enabled=true;
	 	  	  this.thumbVid2.visible = false;

    	} 
    	else if(this.playlist2[combo.selectedIndex].type=="video")		//Video
    	{
    		this.vid2.source = this.playlist2[combo.selectedIndex].file;
    		this.vid2.load();
    		this.vid2.play();
    		if(this.youTubePlaying2)			//Stop youtube if playing
    		{
    			this.youTubePlayer2.stopVideo();
    			this.youTubeStopUpdate2();
    			this.youTubePlaying2 = false;
    			
    		}
    		else //if(SoundChannel2.position!=0) //Stop audio if playing
    		{
    			SoundChannel2.stop();
    			AudioTimer2.stop();
    		}	
 	  		fileLength2 = this.vid2.totalTime;
 	  		this.startSlider2.enabled=true;
 	  		this.endSlider2.enabled=true;
 	  		this.timeLoopBgn2.text="0:00";
 	  		this.loopBtn2.enabled=true;	
 	  		this.thumbVid2.visible = true;
    	}
    	else						 									//YouTube
    	{
    		if(this.vid2.playing) //stop video if playing
    		{
    			this.vid2.stop();
    		}
    		else //if(SoundChannel2.position!=0) //Stop audio if playing
    		{
    			SoundChannel2.stop();
    			AudioTimer2.stop();
    		} 
    		var w2:Number = this.videoUIComp.width;
    		var h2:Number = this.videoUIComp.height;
    		this.youTubePlayer2.setSize(w2,h2);
    		this.youTubePlaying2 = true;
    		this.youTubePlayer2.playVideo();
    		this.youTubeStartUpdate2();
    		
    		this.startSlider2.enabled=true;
 	  		this.endSlider2.enabled=true;
 	  		this.timeLoopBgn2.text="0:00";
 	  		this.loopBtn2.enabled=true;
    	}
    	pausePos2=0;  		
  	}
  }
  
  private function selectionChanged1():void {
  	if(this.playlist1[this.vidPlaying1.selectedIndex].type=="youtube")
  	{
  		var videoId:String = playlist1[this.vidPlaying1.selectedIndex].file;
  		this.youTubePlayer1.onVideoSelected(videoId);
  		this.youTubeThumb1.onVideoSelected(videoId);
  	}
  }
  
  private function selectionChanged2():void {
  	if(this.playlist2[this.vidPlaying2.selectedIndex].type=="youtube")
  	{
  		var videoId:String = playlist2[this.vidPlaying2.selectedIndex].file;
  		this.youTubePlayer2.onVideoSelected(videoId);
  		this.youTubeThumb2.onVideoSelected(videoId);
  	}
  	
  }
  
   private function StartCamera(vid:VideoDisplay):void
  {
 	 cam=Camera.getCamera();
 	 vid.attachCamera(cam);
 	 if(vid.playing)
  	 {
  	  vid.stop();	 
  	 } 
  }
  
  
  private function progressHandler1(event:ProgressEvent):void
  {
  	
    this.progBar1.setProgress(event.bytesLoaded,event.bytesTotal);
    fileTotalBytes1 = event.bytesTotal;
       
  }
  
   private function progressHandler2(event:ProgressEvent):void
  {
  	
    this.progBar2.setProgress(event.bytesLoaded,event.bytesTotal);
    fileTotalBytes2 = event.bytesTotal;
       
  }
 
  private function video1Progress(event:ProgressEvent):void
  {
  	this.progBar1.setProgress(event.bytesLoaded, event.bytesTotal);
    this.fileTotalBytes1 = event.bytesTotal;
    if(event.bytesLoaded == event.bytesTotal)
    {
      this.fileLength1 = this.vid1.totalTime;
      this.timeLoopEnd1.text=formatTime(this.vid1.totalTime); 
      endLoop1=this.vid1.totalTime;
      this.endSlider1.value = this.vid1.totalTime;	
    }
  }
  
    private function video2Progress(event:ProgressEvent):void
  {
  	this.progBar2.setProgress(event.bytesLoaded, event.bytesTotal);
    this.fileTotalBytes2 = event.bytesTotal;
    if(event.bytesLoaded == event.bytesTotal)
     {
  	  this.fileLength2 = this.vid2.totalTime;
      this.timeLoopEnd2.text=formatTime(this.vid2.totalTime); 
      endLoop2=this.vid2.totalTime;
     } 
  }
  
  private function sound1Loaded(event:Event):void
  {
  	fileLength1 = sound1.length;
  	this.startSlider1.value=0;
  	this.endSlider1.value=sound1.length;
  	startLoop1=0;
  	endLoop1=sound1.length;
  	this.timeLoopEnd1.text=formatTime(fileLength1/1000);
  }
  
 
  
    private function sound2Loaded(event:Event):void
  {
  	fileLength2 = sound2.length;
  	this.startSlider2.value=0;
  	this.endSlider2.value=sound2.length;
  	startLoop2=0;
  	endLoop2=sound2.length;
  	this.timeLoopEnd2.text=formatTime(fileLength2/1000);
  }
  
  

  //Video 1: Function to update time display,progress bar and the loop function
  private function playUpdate1():void
  {
    this.playbackProgress1.value=this.vid1.playheadTime;
    this.timeDisp1.text = formatTime(this.vid1.playheadTime)+" / "+formatTime(this.vid1.totalTime);
    //Check video current time with that of the loop controls
    if(Math.floor(this.vid1.playheadTime)==Math.floor(endLoop1))
     {
      this.vid1.playheadTime = this.startLoop1; 
      this.vid1.play();
     } 
  }
  
  //Video 2: Function to update time display,progress bar and the loop function
   private function playUpdate2():void
  {
    this.playbackProgress2.value=this.vid2.playheadTime;
    this.timeDisp2.text = formatTime(this.vid2.playheadTime)+" / "+formatTime(this.vid2.totalTime);
    //Check video current time with that of the loop controls
    if(Math.floor(this.vid2.playheadTime)==Math.floor(endLoop2))
     {
      this.vid2.playheadTime = this.startLoop2; 
      this.vid2.play();
     } 
  }
  
  
  
  //Audio 1: Function to update time display,progress bar and the loop function
  public function updateAudio1(e:Event):void
  {
  	
  	this.playbackProgress1.value = SoundChannel1.position;
  	this.timeDisp1.text = formatTime(SoundChannel1.position / 1000)+"/"+formatTime(fileLength1/1000);
  	this.playbackProgress1.value = SoundChannel1.position; 
  	 //Check sound current time with that of the loop controls
    if(Math.floor(SoundChannel1.position/1000)==Math.floor(endLoop1/1000))
     {
      SoundChannel1.stop();
      SoundChannel1 = sound1.play(startLoop1, 1, SoundTransform1); 
     } 
  	
  }
  
  
  //Audio 2: Function to update time display,progress bar and the loop function
  public function updateAudio2(e:Event):void
  {
  	
  	this.playbackProgress2.value = SoundChannel2.position;
  	this.timeDisp2.text = formatTime(SoundChannel2.position / 1000)+"/"+formatTime(fileLength2/1000);
  	this.playbackProgress2.value = SoundChannel2.position;
  	//Check sound current time with that of the loop controls 
    if(Math.floor(SoundChannel2.position/1000)==Math.floor(endLoop2/1000))
     {
      SoundChannel2.stop();
      SoundChannel2 = sound2.play(startLoop2, 1, SoundTransform2); 
     } 
  	
  }
  
  
   //Function to format the time display 
  private function formatTime(value:int):String
  {
	var result:String = (value % 60).toString();
    if (result.length == 1)
      result = Math.floor(value / 60).toString() + ":0" + result;
    else 
     result = Math.floor(value / 60).toString() + ":" + result;
    return result;
  } 
  
  

  
  //Pause media function
  private function pauseMedia(ctrl:int):void
  {
  	if (ctrl == 1)
  	 {
  	 	if(vid1.playing==true)
  	 	 	this.vid1.pause();
  	 	else if(vidPlaying1.selectedLabel=="Camera") 
  	 	 	this.vid1.attachCamera(null);
  	 	else if(this.youTubePlaying1)
  	 		this.youTubePlayer1.pauseVideo();
  	 	else
  	 	{
  	 		pausePos1 = SoundChannel1.position;
  	 		this.SoundChannel1.stop();	
  	 	}	   
  	 	
  	 	
  	 }
  	if (ctrl == 2)
  	 {
  	 	if(vid2.playing==true)
  	 	 	this.vid2.pause();
  	 	else if(vidPlaying2.selectedLabel=="Camera") 
  	 	 	this.vid2.attachCamera(null);
  	 	else if(this.youTubePlaying1)
  	 		this.youTubePlayer2.pauseVideo();
  	 	else
  	 	{
  	 		pausePos2 = SoundChannel2.position;
  	 		this.SoundChannel2.stop();
  	 	}	   
  	 } 
  }
  
  
  //Adjust Volume function for audio files
  private function adjustVolume(ctrl:int,reset:Boolean):void
  {
  	var soundTrans:SoundTransform = new SoundTransform();
  	var fillColorsAct:Array= [ "#00000", "#000000" ];
  	if(ctrl == 1)
  	 {
  	 	soundTrans.volume = this.volSlider1.value;
  	 	SoundChannel1.soundTransform = soundTrans; 
  	 	this.youTubePlayer1.setVolume(volSlider1.value*100);
  	 	//Change color back to normal in case sound was muted
  	 	if(reset)
  	 	{
 	 		this.muteBtn1.setStyle("color","#FFFFFF");	
 	  		this.muteBtn1.setStyle('fillColors',fillColorsAct);
 	  	}		
  	 	
  	 }
  	else
  	 {
  	 	soundTrans.volume = this.volSlider2.value;
  	 	SoundChannel2.soundTransform = soundTrans;
  	 	this.youTubePlayer2.setVolume(volSlider2.value*100);
  	 	//Change color back to normal in case sound was muted
  	 	if(reset)
 	 	{
 	 		this.muteBtn2.setStyle("color","#FFFFFF");	
 	  		this.muteBtn2.setStyle('fillColors',fillColorsAct);	
 	 	}	
  	 } 
  }
  
  
  
  //Function to mute sound
  private function muteSound(audio:uint):void
 {
 	var fillColorsAct:Array= [ "#00000", "#000000" ];
 	var fillColorsMute:Array=[ "#FF0000", "#FF0000" ];
   if(audio==1)
   {	
 	 if(this.volSlider1.value!=0)
 	 {
 	  volume1=this.volSlider1.value;
 	  this.volSlider1.value=0;
 	  //COLOR BUTTON	
 	  this.muteBtn1.setStyle("color","#000000");	
 	  this.muteBtn1.setStyle("fillColors",fillColorsMute);	 	
 	 }
 	else
 	 {
 	  this.volSlider1.value=volume1;
 	  this.muteBtn1.setStyle("color","#FFFFFF");	
 	  this.muteBtn1.setStyle("fillColors",fillColorsAct);	 
 	 } 
 	 adjustVolume(1,false);
   }
  if (audio==2)
   {

 	 if(this.volSlider2.value!=0)
 	 {
 	  volume2=this.volSlider2.value;
 	  this.volSlider2.value=0;
 	  this.muteBtn2.setStyle("color","#000000");	
 	  this.muteBtn2.setStyle("fillColors",fillColorsMute);		
       	 
 	 }
 	else
 	 {
 	  this.volSlider2.value=volume2;
 	  //COLOR BUTTON
 	  this.muteBtn2.setStyle("color","#FFFFFF");	
 	  this.muteBtn2.setStyle('fillColors',fillColorsAct);	 
 	 } 
 	 	
   }
   adjustVolume(2,false);
 }
  
 //
  private function OnAlpha(alValue:Number):void
  {
       vid2.alpha=alValue;
       vid1.alpha=1-alValue;
  }
  
  //This function is used to display the start frame of video in loop panel
  private function OnReady(vid:VideoDisplay):void
  {
    vid.playheadTime=0.5;
  	vid.pause();
  }
  
  
  //JumpTo  playback function
  private function JumpTo(ctrl:int, pos:SliderEvent):void
  {
  	
  	//Deck A
  	if(ctrl==1)
  	 {
  	 	//Determine if "deck" plays video, audio or youtube
  	 	//Video
  	 	if(this.vid1.state == "playing" || this.vid1.state == "paused")
  	 	 {
  	 	  this.vid1.playheadTime = pos.value;	
  	 	 }
  	 	 
  	 	 else if (SoundChannel1.position!=0 && this.playlist1[this.vidPlaying1.selectedIndex].type=="audio")
  	 	 {
  	 	   SoundChannel1.stop();
    	   SoundChannel1 = sound1.play(pos.value, 1, SoundTransform1); 	
  	 	 }
  	 	 else if(this.youTubePlaying1)
  	 	 {
  	 	 	this.youTubePlayer1.seekTo(pos.value,true);
  	 	 }
  	 	 
  	 	 
  	 }
  	 //Deck B
  	 if(ctrl==2)
  	 {
  	 	//Determine if "deck" plays video, audio or youtube
  	 	//Video
  	 	if(this.vid2.state == "playing" || this.vid2.state == "paused")
  	 	 {
  	 	  this.vid2.playheadTime = pos.value;	
  	 	 }
  	 	 //Audio
  	 	 else if (SoundChannel2.position!=0 && this.playlist2[this.vidPlaying2.selectedIndex].type=="audio")
  	 	 {
  	 	   SoundChannel2.stop();
    	   SoundChannel2 = sound2.play(pos.value, 1, SoundTransform2); 	
  	 	 }
  	 	  else if(this.youTubePlaying2)
  	 	 {
  	 	 	this.youTubePlayer2.seekTo(pos.value,true);
  	 	 }
  	 }
  }
  
  //Seek To playback function
  private function seekToPos(ctrl:int):void
  {
  	  	
  	//Deck A
  	if(ctrl==1)
  	 {
  	 	//Determine if "deck" plays video, audio or youtube
  	 	//Video
  	 	if(this.vid1.state == "playing" || this.vid1.state == "paused")
  	 	 {
  	 	  this.vid1.playheadTime = seekTo;	
  	 	 }
  	 	 
  	 	 else if (SoundChannel1.position!=0 && this.playlist1[this.vidPlaying1.selectedIndex].type=="audio")
  	 	 {
  	 	   SoundChannel1.stop();
    	   SoundChannel1 = sound1.play(seekTo, 1, SoundTransform1); 	
  	 	 }
  	 	 else if(this.youTubePlaying1)
  	 	 {
  	 	 	this.youTubePlayer1.seekTo(seekTo,true);
  	 	 }
  	 	 
  	 }
  	 //Deck B
  	 if(ctrl==2)
  	 {
  	 	//Determine if "deck" plays video, audio or youtube
  	 	//Video
  	 	if(this.vid2.state == "playing" || this.vid2.state == "paused")
  	 	 {
  	 	  this.vid2.playheadTime = seekTo;	
  	 	 }
  	 	 //Audio
  	 	 else if (SoundChannel2.position!=0 && this.playlist2[this.vidPlaying2.selectedIndex].type=="audio")
  	 	 {
  	 	   SoundChannel2.stop();
    	   SoundChannel2 = sound2.play(seekTo, 1, SoundTransform2); 	
  	 	 }
  	 	  else if(this.youTubePlaying2)
  	 	 {
  	 	 	this.youTubePlayer2.seekTo(seekTo,true);
  	 	 }
  	 }
  }
  
  //Sets the video time to the beggining of the loop. 
  private function Loop(video1:Boolean):void
  {
  	if(video1)
  	{
  		//Determine if "deck" plays video, audio or youtube
  	 	//Video
  	 	if(this.vid1.state == "playing" || this.vid1.state == "paused")
  	 	 {
  	 	  this.vid1.playheadTime = this.startLoop1;
  	 	  this.vid1.play();	
  	 	 }
  	 	 //Audio
  	 	 else if (SoundChannel1.position!=0 && this.playlist1[this.vidPlaying1.selectedIndex].type=="audio")
  	 	 {
  	 	   SoundChannel1.stop();
    	   SoundChannel1 = sound1.play(startLoop1, 1, SoundTransform1); 	
  	 	 }
  	 	 //YouTube
  	 	 else if(this.youTubePlaying1)
  	 	 {
  	 	 	this.youTubePlayer1.seekTo(startLoop1,true);
  	 	 }
  		
  		
  	}
  	else
  	{
  			//Determine if "deck" plays video, audio or youtube
  	 	//Video
  	 	if(this.vid2.state == "playing" || this.vid2.state == "paused") 
  	 	 {
  	 	  this.vid2.playheadTime = this.startLoop2;
  	 	  this.vid2.play();	
  	 	 }
  	 	 //Audio
  	 	 else if (SoundChannel2.position!=0 && this.playlist2[this.vidPlaying2.selectedIndex].type=="audio")
  	 	 {
  	 	   SoundChannel2.stop();
    	   SoundChannel2 = sound1.play(startLoop2, 1, SoundTransform2); 	
  	 	 }
  	 	 //YouTube
  	 	 else if(this.youTubePlaying2)
  	 	 {
  	 	 	this.youTubePlayer2.seekTo(startLoop2,true);
  	 	 }
  		
  	}	
  }
 
 
 //Function for the control of loop sliders
 //Value of each  slider (time) is checked according to each function 
 //Skip variable is used to skip the thumbnail update of loop monitors, in order to avoid update delays 
 private function dragLoopSlider(slider:HSlider, timeLabel:Label,skip:Boolean):Number
 {
  var Loop:Number=slider.value;
  if(slider.value>1000)
   timeLabel.text=formatTime(slider.value/1000);
  else
   timeLabel.text=formatTime(slider.value);
  //Get thumbnail
  //Check if start loop time is greater than end loop time and vice versa
  if(slider.id=="startSlider1")
   {
   	if(this.vid1.state == "playing" || this.vid1.state == "paused")
   	{
     if(!skip)	
   	  		this.thumbVid1.playheadTime=slider.value;
   	}
   	else if(this.youTubePlaying1)
   	{
   		if(!skip)
   		{
   			this.youTubeThumb1.seekTo(slider.value,true);
   			this.youTubeThumb1.pauseVideo();
   		}	
   	}  
    if(slider.value>=this.endSlider1.value)
      {
        endSlider1.value=startSlider1.value+1;
        endLoop1=dragLoopSlider(this.endSlider1,this.timeLoopEnd1,true);
      } 
   } 
   
   
  else if(slider.id=="startSlider2")
   {
   	 if(this.vid2.state == "playing" || this.vid2.state == "paused")
   	 {
   	  if(!skip)
   	   this.thumbVid2.playheadTime=slider.value;
   	 }
     else if(this.youTubePlaying2)
   	 {
   		if(!skip)
   		{
   			this.youTubeThumb2.seekTo(slider.value,true);
   			this.youTubeThumb2.pauseVideo();
   		}	
   	 }  
   	 if(slider.value>=this.endSlider2.value)
   	 {
      endSlider2.value=startSlider2.value+1;
      endLoop2=dragLoopSlider(this.endSlider2,this.timeLoopEnd2,true);
     } 
   } 
   
  else if(slider.id=="endSlider1")
   {
   	 if(this.vid1.state == "playing" || this.vid1.state == "paused")
   	 {
   	  if(!skip)
   	   		this.thumbVid1.playheadTime=slider.value;
   	 }
   	 else if(this.youTubePlaying1)
   	{
   		if(!skip)
   		{
   			this.youTubeThumb1.seekTo(slider.value,true);
   			this.youTubeThumb1.pauseVideo();
   		}	
   	}    
   	 if(slider.value<=this.startSlider1.value)
   	  {
        startSlider1.value=slider.value-1;
        startLoop1=dragLoopSlider(this.startSlider1,this.timeLoopBgn1,true);
      }  
   } 
   
  else if (slider.id=="endSlider2")
  {
  	if(this.vid2.state == "playing" || this.vid2.state == "paused")
  	{
  	 if(!skip)
       this.thumbVid2.playheadTime=slider.value;
   }
     else if(this.youTubePlaying2)
   	{
   		if(!skip)
   		{
   			this.youTubeThumb2.seekTo(slider.value,true);
   			this.youTubeThumb2.pauseVideo();
   		}	
   	}     	
  	if(slider.value<=this.startSlider2.value)
  	 {
       startSlider2.value=slider.value-1;
       startLoop2=dragLoopSlider(this.startSlider2,this.timeLoopBgn2,true);
     }  
  } 
  return Loop;
 } 
 
 private function TabNav():void
 {
 	if(tabnavigator1.selectedIndex==1)
 	 filtersPanel.visible=true;
 	else
 	 filtersPanel.visible=false; 
 }
 
//Play next function
private function playNext1():void
{
	if(this.vidPlaying1.selectedIndex==this.vidPlaying1.rowCount)
 		this.vidPlaying1.selectedIndex=0;
 	else
 		this.vidPlaying1.selectedIndex++;
    playVideo(vid1,vidPlaying1);

} 

private function playNext2():void
{
	if(this.vidPlaying2.selectedIndex==this.vidPlaying2.rowCount)
 		this.vidPlaying2.selectedIndex=0;
 	else
 		this.vidPlaying2.selectedIndex++;
    playVideo(vid2,vidPlaying2);

} 

//Play previous function

private function playPrevious1():void
{
	if(this.vidPlaying1.selectedIndex==0)
 		this.vidPlaying1.selectedIndex=this.vidPlaying1.rowCount;
 	else
 		this.vidPlaying1.selectedIndex--;
    playVideo(vid1,vidPlaying1);

} 

private function playPrevious2():void
{
	if(this.vidPlaying2.selectedIndex==0)
 		this.vidPlaying2.selectedIndex=this.vidPlaying2.rowCount;
 	else
 		this.vidPlaying2.selectedIndex--;
    playVideo(vid2,vidPlaying2);

} 

private function showFilterTip():void {
	Alert.show("Drag and drop filter to selected filter list");
}

